#include <boost/spirit/core.hpp>
#include <boost/spirit/dynamic/lazy.hpp>
#include <boost/spirit/utility/chset.hpp>
#include <boost/spirit/phoenix/primitives.hpp>
#include <boost/scoped_ptr.hpp>
#include <boost/scoped_array.hpp>
#include "Saori.hpp"

#include <windows.h>

// パース
void request_parser::parse()
{
    using namespace boost::spirit;
    using namespace phoenix;
    
    subrule<0> main;
    subrule<1> head;
    subrule<2> args;
    subrule<3> secu;
    subrule<4> chst;
    subrule<5> send;
    subrule<5> other;
    
    // 最早何をやっているか説明する気になれない
    // まったくあやふやなBNFだ。正しくないし。というかもう少し融通を利かせたほうがいい。
    // それにしても引数の関数オブジェクトにphoenixとかを使うと簡単に悲鳴を上げる。
    // 軟弱なコンパイラだ。
    // とコンパイラを虐めて遊ぶのも面白いもんだ。
    if(!boost::spirit::parse(
        _request_data.begin(), _request_data.end(),
        (
            main = head >> *(args | secu | chst | send | other) >> "\r\n" >> *anychar_p,
            head = (str_p("GET Version") | "EXECUTE")[assign_a(_command)] >> " SAORI/1.0\r\n",
            args = "Argument" >> lazy_p(val(int_p))[assign_a(n)] >> ": " >> 
                    (*(anychar_p - chset<>("\r\n")))[set_arg_t(this)] >> "\r\n",
            secu = "SecurityLevel: " >> 
                    (*(anychar_p - chset<>("\r\n")))[assign_a(_securitylevel)] >> "\r\n",
            chst = "Charset: " >> 
                    (*(anychar_p - chset<>("\r\n")))[assign_a(_charset)] >> "\r\n" ,
            send = "Sender: " >> 
                    (*(anychar_p - chset<>("\r\n")))[assign_a(_sender)] >> "\r\n" ,
            other = *(anychar_p - ':') >> ": " >> *(anychar_p - chset<>("\r\n")) >> "\r\n" 
        )).full)
        throw saori_error(SAORI_400_Bad_Request, "Parser error.");
    
    return;
}

// 
saori_interface_base *_saori_interface_object_for_module_;
 

// load 関数
extern "C" __declspec(dllexport) BOOL __cdecl load (HGLOBAL h, long len)
{
    boost::scoped_ptr<saori_con_base> saori_controler(saori_controler_initialize());
    // 渡された文字列はstringに渡す前にこちらでコピーしておいたほうがいいような気が
    boost::scoped_array<char> path(new char[len + 1]); 
    // コピー
    memcpy(path.get(), h, len); 
    path[len] = 0; 
    saori_controler->load(path.get());
    // 忘れがち
    GlobalFree(h); 
    return TRUE; 
}


// unload 関数 
extern "C" __declspec(dllexport) BOOL __cdecl unload () 
{
    boost::scoped_ptr<saori_con_base> saori_controler(saori_controler_initialize());
    saori_controler->unload();
    return TRUE; 
} 


// request関数
extern "C" __declspec(dllexport) HGLOBAL __cdecl request (HGLOBAL h, long *len) 
{ 
    boost::scoped_ptr<saori_con_base> saori_controler(saori_controler_initialize());
    std::string res; 
    HGLOBAL hres;
    
    boost::scoped_array<char> req(new char[*len + 1]);
    memcpy(req.get(), h, *len); 
    saori_controler->request(req.get(), res);
    req[*len] = 0; 
    
    // 開放
    GlobalFree(h);
    *len = res.length() + 1;
    hres = GlobalAlloc(GMEM_FIXED, *len); 
    memcpy(hres, res.c_str(), *len); 
    return hres; 
}


// メイン関数
BOOL WINAPI DllMain(HINSTANCE, DWORD, LPVOID)
{
    return TRUE;
}
